$(document).ready(function() {
    var cw = 10;
    var canvas = $("#canvas")[0];
    var w = canvas.width;
    var h = canvas.height;
    var ctx = canvas.getContext("2d");

    var score;
    var food;
    var dir;

    var Snake;

    var CheckCollision = function(x, y, array) {
      //This function will check if the provided x/y coordinates exist
      //in an array of cells or not
      for(var i = 0; i < array.length; i++)
      {
        if(array[i].x == x && array[i].y == y)
         return true;
      }
      return false;
    };

    var PaintCell = function(x, y) {
      ctx.fillStyle = "blue";
      ctx.fillRect(x*cw, y*cw, cw, cw);
      ctx.strokeStyle = "white";
      ctx.strokeRect(x*cw, y*cw, cw, cw);
    };

    var Paint = function() {
      ctx.fillStyle = "white";
      ctx.fillRect(0, 0, w, h);
      ctx.strokeStyle = "black";
      ctx.strokeRect(0, 0, w, h);

      var nx = Snake[0].x;
      var ny = Snake[0].y;

      if(dir == "right") nx++;
      else if(dir == "left") nx--;
      else if(dir == "up") ny--;
      else if(dir == "down") ny++;

      if(nx == -1 || nx == w/cw || ny == -1 || ny == h/cw || CheckCollision(nx, ny, Snake))
      {
        //restart game
        Init();
        //Lets organize the code a bit now.
        return;
      }

      //Lets write the code to make the snake eat the food
      //The logic is simple
      //If the new head position matches with that of the food,
      //Create a new head instead of moving the tail
      if(nx == food.x && ny == food.y)
      {
        var tail = {x: nx, y: ny};
        score++;
        //Create new food
        CreateFood();
      }
      else
      {
        var tail = Snake.pop(); //pops out the last cell
        tail.x = nx; tail.y = ny;
      }

      Snake.unshift(tail); 

      for(var i = 0; i < Snake.length; i++)
      {
        var c = Snake[i];
        PaintCell(c.x, c.y);
      }

      PaintCell(food.x, food.y);
      var score_text = "Score: " + score;
      ctx.fillText(score_text, 5, h-5);
    };

    var Init = function() {
      dir = "right"; 
      CreateSnake();
      CreateFood(); 
      score = 0;
      if( typeof(game_loop) != "undefined" ) {
        clearInterval(game_loop);
      }
      game_loop = setInterval(Paint, 60);
    };

    var CreateSnake = function() {
      var length = 1;
      Snake = []; 
      for(var i = length-1; i>=0; i--) {
        Snake.push({x: i, y:0});
      }
    };

    var CreateFood = function() {
      food = {
        x: Math.round(Math.random()*(w-cw)/cw), 
        y: Math.round(Math.random()*(h-cw)/cw), 
      };
    };

    Init();

    $(document).keydown(function(e){
      var key = e.which;
      if(key == "37" && dir != "right") dir = "left";
      else if(key == "38" && dir != "down") dir = "up";
      else if(key == "39" && dir != "left") dir = "right";
      else if(key == "40" && dir != "up") dir = "down";
    });
});
